\section{Web Application Hacking}
\includegraphics[width=0.75\linewidth]{webapp}
\subsection{User Credentials}
Attack the user credentials is often the easiest attack vector, e. g by social engineering. Security Awareness Training seems to help somehow if used wisely.  Obviously 2FA (2Factor Authentication) increases the difficulty of a successful attack. \\
\includegraphics[width=\linewidth]{usercredentials} \\
\subsubsection{Passowrd breached?}
NIST SP 800-63b: When processing requests to establish and change memorized secrets, verifiers SHALL compare the prospective secrets against a list that contains values known to be commonly-used, expected, or compromised. For example, the list MAY include, but is not limited to.
\subsection{OWASP Top 10}
The OWASP Top 10 is a standard awareness document for developers and web application security. It represents a broad consenus about the most critical security risks to web appliactions. \\
\includegraphics[width=0.75\linewidth]{owasp} \\
\includegraphics[width=0.75\linewidth]{owasp10} \\
\includegraphics[width=0.75\linewidth]{owasp102}

\subsubsection{A1 Injection}
Easy to exploit but also easy to avoid. Validate and sanitize the user input!
There are different types of injection attacks: SQL Injections, LDAP XPath statements, XML and SOAP, Operating System Commands, E-mail services / SMTP, Cross-site scripting.
Rules for robust validation: server side: exception for DOM-based XSS, Fixed Character Set, Canonicalization Only before validation. \\
\includegraphics[width=0.75\linewidth]{A1} \\
\includegraphics[width=0.75\linewidth]{A1example}
\subsubsection{A2 Broken Authenthication}
Mitigations: where possible, implement MFA to prevent automated, credential stuffing, brut force and stolen credential re-use attacks. Verify application implementation.
\subsubsection{A3 Sensitive Data Exposure}
Mitigation: Verify your architecture, identify all sensitive data, identify all the places that data is stored, ensure threat model accounts for possible attacks. \\
\includegraphics[width=0.75\linewidth]{owaspa3}
\subsubsection{A4 XML eXternal Entitiy (XEE) Attacks}
Attackers can exploit vulnerable XML processors if they can upload XML or include hostile content in an XML document, exploiting vulnerable code, dependencies or integrations. 
\subsubsection{A5 Broken Access Control}
A direct object reference occurs when an application exposes an internal object (or resource), such as a file, directory, database record, or key, through its client interface, e.g. as a URL or form parameter. An attacker can manipulate direct object references to access other objects without authorization, unless an access control check is in place.  Mitigations: Proper access control, indirect reference maps, input validation.
\subsubsection{A6 Security Misconfiguration}
There is a long list of possibilities, including but not limited to: outdated and vulnerable software in production, default admin accounts, security info leakage etc. \\
Mitigations: Harden Systems, do not deploy in production hidden admin or testing functionality. Use generic error messages.
\subsubsection{Cross-Site Scripting (XSS)}
There are three types of XSS attacks: Stored (example given), Reflected (The attack payload is delivered and executed via a single request and response), DOM-based (Everything could happen on the browser side!) \\
Mitigations: Using frameworks that automatically escape XSS by design, applying context-sensitive encoding, enabling a content security policy. \\
\textbf{Output Sanitizaiton}
 Encode the data before inserting it into the code context, in order to neutralize the malicious characters.
\subsubsection{A8 Insecure Deserilaziation}
A PHP forum uses PHP object serialization to save a "super" cookie, containing the user's user ID, role, password hash, and other state.
\subsubsection{A9 Using known vulnerable components}
 In a nutshell: Know where you are blank! 
 \subsubsection{A10 Insufficient Logging and Monitoring}
 Web applications are written with user friendliness in mind: they usually just tell users about error and ask them to not try again.
